<?php

/**
 * inf_registro_resol actions.
 *
 * @package    controlComisiones
 * @subpackage inf_registro_resol
 * @author     Your name here
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class inf_registro_resolActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'COM_RESOLUCION',
        'COM_COMISION',
        'PROYECTOS',
        'TIPOS_COMISION',
        'AREA',
        'COM_TIPO_DESTINO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'COM_COMISION' =>
        array(
            'id_comision' => 'COM_RESOLUCION'
        ),
        'PROYECTOS' =>
        array(
            'id_proyecto-id' => 'COM_COMISION'
        ),
        'TIPOS_COMISION' =>
        array(
            'id_tipo_comision' => 'COM_COMISION'
        ),
        'AREA' =>
        array(
            'id_area' => 'COM_COMISION'
        ),
        'COM_TIPO_DESTINO' =>
        array(
            'id_tipo_destino' => 'COM_COMISION'
        )    
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'COM_RESOLUCION' =>
        array(
            'id_resolucion' => 'id_resolucion',
            'id_comision' => 'id_comision',
            'no_resolucion' => 'no_resolucion',
            'fecha_resolucion' => 'fecha_resolucion',
            'id_anhos' => 'id_anhos',
            'estado' => 'estado',
            'fecha_anulacion' => 'fecha_anulacion',
            'motivo_anulacion' => 'motivo_anulacion',
        ),
        'COM_COMISION' =>
        array(
            'no_comision' => 'no_comision',
            'fecha_solicitud' => 'fecha_solicitud',
            'id_proyecto' => 'id_proyecto',
            'objeto' => 'objeto',
            'agenda' => 'agenda',
            'id_area' => 'id_area',
            'fecha_inicio' => 'fecha_inicio_comi',
            'fecha_fin' => 'fecha_fin_comi',
            'id_tipo_destino' => 'id_tipo_destino'
        ),
        'PROYECTOS' =>
        array(
            'descripcion' => 'descripcion_cm',
            'codigo' => 'codigo_cm'
        ),
        'TIPOS_COMISION' =>
        array(
            'descripcion' => 'descripcion_tipcom'
        ),
        'AREA' =>
        array(
            'descripcion' => 'area'
        ),
        'COM_TIPO_DESTINO' =>
        array(
            'descripcion' => 'tipo_destino'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'id_anhos', 'codigo_cm', 'no_resolucion', 'no_comision', 'estado'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'COM_RESOLUCION' =>
        array(
            'id_resolucion,a' => array('!=' => array(-1)),
            'id_resolucion,b' => array('=' => array('id_resolucion')),
            'id_comision' => array('=' => array('id_comision')),
            'no_resolucion' => array('=' => array('no_resolucion')),
            'fecha_resolucion' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'estado' => array('=' => array('estado')),
            'id_anhos' => array('=' => array('id_anhos')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'COM_COMISION' =>
        array(
            'no_comision' => array('=' => array('no_comision')),
            'id_proyecto' => array('=' => array('id_proyecto')),
            'id_area' => array('=' => array('id_area')),
            'id_tipo_destino' => array('=' => array('id_tipo_destino'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_resolucion'; //identificador de la tabla
    protected $id_names = array('id_resolucion'); //llave primaria
    protected $field_names = array('id_comision', 'no_resolucion', 'fecha_resolucion', 'estado', 'id_anhos', 'fecha_anulacion', 'motivo_anulacion'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'COM_RESOLUCION'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_resolucion'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {
            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {
            
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;


        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
